;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;  MultiThread 
;;;
;;;  
;;; All Right Reserved, 2001 (C) CopyRight by GOMI Hiroshi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; 7-Feb-2001: starts

;;;
;;; P̃Xbh̏I҂ČʂԂ
;;;
(defun sync (te)
   (sleep 100)
   (if (finishp te)
       (result te)
       (sync te)))

;;;
;;; 2̃Xbh̏I҂ČʂԂ
;;; Ehr
(defun sync2 (te1 te2)
   (sleep 100)
   (if (finishp te1)
       (list (result te1) (sync te2))
       (if (finishp te2)
           (list (sync te1) (result te2))
           (sync2 te1 te2))))

;;;
;;; 3̃Xbh̏I҂ČʂԂ
;;; Ehr
(defun sync3 (te1 te2 te3)
   (sleep 100)
   (if (finishp te1)
       (nconc (list (result te1)) (sync2 te2 te3))
       (if (finishp te2)
           (sync3' (result te2) (sync2 te3 te1))
           (if (finishp te3)
               (nconc (sync2 te1 te2) (list (result te3)))
               (sync3'' (sync3 te2 te3 te1)) ))))         

(defun sync3' (te2 te31)
   (list (second te31) te2 (first te31)))

(defun sync3'' (te231)
   (list (third te231) (first te231) (second te231))) 

;;;
;;; A^Cj^
;;;
(defun monitor (var-list usrID)
   (monitor-aux var-list usrID 20 0))

(defun monitor-aux (var-list usrID count iii)
   (loop 
     (sleep 1000)
     (if (symbolp var-list)
         (monitor-write var-list)
         (mapcar 'monitor-write var-list))
     (terpri)
     (if (= iii count) (return nil))
     (setq iii (+ iii 1))
      ))

(defun monitor-write (var)
   (write var) 
   (write " = ")
   (write (getValue var usrID))
   (write ".  ") )

(defun getValue (var usrID)
   (if (= usrID 0)
       (value-of var)
       (get usrID (value-of var t))))

;;;
;;; all-user-set
;;;
(defun all-user-set (var val)
   (set var val)
   (set-muset (value-of var t) val)
   val)

(defun set-muset (var-list val)
   (if (null var-list)
       nil
       (progn (set-cdr (car var-list) val)
              (set-muset (cdr var-list) val))))    
