;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;;  ֐ tak
;;;      tak,  tak
;;;     x`}[Np֐ bench
;;;
;;;  All Right Reserved, 2001 (C) CopyRight by GOMI Hiroshi
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun tak (x y z)
    (if (>= y x)
        z 
        (tak (tak (- x 1) y z) 
             (tak (- y 1) z x) 
             (tak (- z 1) x y))))

(defun bench ()
   (list 
     (checktime '(tak 18 12 6) 'tak6 0 0)
     (checktime '(tak 21 14 7) 'tak7 0 0)
     (checktime '(tak 18.0 12.0 6.0) 'tak6.0 0 0)
     (checktime '(tak 21.0 14.0 7.0) 'tak7.0 0 0)
     (checktime '(tak 24 16 8) 'tak8 0 0)
   ))

(defun checktime (test msg start end)
   (gc)
   (print msg)
   (setf start (time))
   (eval test)
   (setf end (time))
   (print (- end start)) )

